package com.totopia.server.user.model;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

import com.fasterxml.jackson.annotation.JsonIgnore;

import lombok.Builder;
import lombok.Data;

@Entity
@Table(name = "USER")
@Data
@Builder
public class User implements Serializable {
  private static final long serialVersionUID = 2783105197387637187L;

  @Id
  @GeneratedValue(generator = "user_generator")
  @SequenceGenerator(name = "user_generator", sequenceName = "user_sequence", initialValue = 1000)
  private Long id;

  @Basic
  @Column(name = "name", nullable = false, length = 255)
  private String name;

  @Basic
  @Column(name = "username", nullable = false, length = 150)
  private String username;

  @Basic
  @Column(name = "email", nullable = false, length = 100)
  private String email;

  @Basic
  @Column(name = "password", nullable = false, length = 100)
  @JsonIgnore
  private String password;

  @Basic
  @Column(name = "block", nullable = false, columnDefinition = "bool default false")
  private Boolean block;

  @Basic
  @Column(name = "send_email", nullable = true, columnDefinition = "bool default false")
  private Boolean sendEmail;

  @Basic
  @Column(name = "register_date", nullable = false)
  private Date registerDate;

  @Basic
  @Column(name = "lastvisit_date", nullable = false)
  private Date lastvisitDate;

  @Basic
  @Column(name = "activation", nullable = false, length = 100)
  private String activation;

  @Basic
  @Column(name = "last_reset_time", nullable = false)
  private Date lastResetTime;

  @Basic
  @Column(name = "reset_count", nullable = false)
  private Long resetCount;

  @Basic
  @Column(name = "otp_key", nullable = false, length = 1000)
  private String otpKey;

  @Basic
  @Column(name = "otep", nullable = false, length = 1000)
  private String otep;

  @Basic
  @Column(name = "require_reset", nullable = true, columnDefinition = "bool default false")
  private Boolean requireReset;

}
